changeset 331:eb14375a9741

revive the PHP ebuild for 5.2.17 from Gentoo's portage attic.
author Dirk Olmes <dirk.olmes@iobjects.de>
date Tue, 03 Apr 2012 07:35:12 +0200
parents 88703931ca43
children e9bee0cb5018
files dev-lang/php/Manifest dev-lang/php/files/20php5-envd dev-lang/php/files/70_mod_php5.conf-apache2 dev-lang/php/files/eblits/src_compile-v1.eblit dev-lang/php/files/eblits/src_configure-v521.eblit dev-lang/php/files/eblits/src_install-v2.eblit dev-lang/php/files/eblits/src_prepare-v2.eblit dev-lang/php/files/eblits/src_test-v1.eblit dev-lang/php/php-5.2.17.ebuild
diffstat 9 files changed, 1039 insertions(+), 0 deletions(-) [+]
line wrap: on
line diff
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/dev-lang/php/Manifest	Tue Apr 03 07:35:12 2012 +0200
@@ -0,0 +1,11 @@
+AUX 20php5-envd 145 RMD160 8c81fb7dc1d1ddf16fd956d748514db3bcb27603 SHA1 f1cef57c0def8e2c5422aaf136f40b4ff47801d2 SHA256 efaae9e6ae5f7010e073c2ab6d8a9dda009f0707c7d7b0c027e142c94f7041a4
+AUX 70_mod_php5.conf-apache2 348 RMD160 9f3f49a52ebf92c2650501c5ceb6f95ce4bb2e76 SHA1 62992e793446b4a9a64900d1ecba7bae06873382 SHA256 5bb8a45570582b4389a7d3feea0398e1c13ed4ced96e559b9406ed8c965dea8c
+AUX eblits/src_compile-v1.eblit 1283 RMD160 83fbb374e2dfaa9d164e6b32b57c268ed06bf519 SHA1 09124cbc9008bfb72eb24cd24b2319d22df52c2c SHA256 5ec76ae24304c5f803a615a98394c219018da1b1ce2018f92f6ac8c5becf6c99
+AUX eblits/src_configure-v521.eblit 10844 RMD160 90513f59b5f17d680004d3e74581d9eedc8af490 SHA1 a369e2cf7816799f7e2bead8b6eccc2115d0ecdc SHA256 ad875ca45e9ad975c0d7a3cbedc27c5035aa048d7aa935221a15e47cbca63c3d
+AUX eblits/src_install-v2.eblit 5237 RMD160 d1368ba2f7dfe52e8440afea6c5056fd738f5c10 SHA1 b0df591e1b093bdf08414e21a47bfcf5f09b09ac SHA256 860bf8ada8a4900d6a4bdd29bab3e65aff29ba8ddbbba4bec50d9d29c6990ca4
+AUX eblits/src_prepare-v2.eblit 2604 RMD160 379dbca3e2ae8c1f09f608220ec9c98d099cb792 SHA1 42afae4e07633535ecea49817f5badd559f10ff1 SHA256 fe7534260fb81a012b8021b5d555756ce8733ad192bf51cedd94f12963811790
+AUX eblits/src_test-v1.eblit 1557 RMD160 2afc2b505f2b4bd786635e5b7e997248e93009c3 SHA1 070c2b58b55fc2cec939d7a333057506413e8e99 SHA256 81e9ecf94793377e42508d9e57cd7ab3faff78bce722b84b63999a23bdb2098a
+DIST php-5.2.17.tar.bz2 9092312 RMD160 567fa8d718b93fb83a89494c83a8bec224ac99e9 SHA1 d68f3b09f766990d815a3c4c63c157db8dab8095 SHA256 e81beb13ec242ab700e56f366e9da52fd6cf18961d155b23304ca870e53f116c
+DIST php-patchset-5.2.17-r0.tar.bz2 8369 RMD160 544af4eb2de8e4478e675810f18a5b494b59709b SHA1 7b3c56437b435f60f72f7af08112e77c01e2f827 SHA256 fb159a02faf5120dd9bc620bd3f3094735f181aa6893273bb7dd29771b8b23b2
+DIST suhosin-patch-5.2.16-0.9.7.patch.gz 23069 RMD160 b28b70faf136b3e04c5b483da0f4c2279378f43a SHA1 fec10b2b81582d06bb0d0a96ea55c525afc8ab29 SHA256 aae115a318d80b3f32cedf876e7a8e4b932febb1b0c743c0b398003ebe122f91
+EBUILD php-5.2.17.ebuild 11400 RMD160 442ce96fc819167fe093b1ff754da17b98812805 SHA1 e808e9b24dcfee8f75e8ea465b964a965151f513 SHA256 1e82c08f4348f02817a0932030ecfaa741de1933edda9e884042b9a83aa6b267
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/dev-lang/php/files/20php5-envd	Tue Apr 03 07:35:12 2012 +0200
@@ -0,0 +1,2 @@
+MANPATH="/usr/lib/php5/man/"
+CONFIG_PROTECT_MASK="/etc/php/cli-php5/ext-active/ /etc/php/cgi-php5/ext-active/ /etc/php/apache2-php5/ext-active/"
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/dev-lang/php/files/70_mod_php5.conf-apache2	Tue Apr 03 07:35:12 2012 +0200
@@ -0,0 +1,14 @@
+<IfDefine PHP5>
+	# Load the module first
+	<IfModule !mod_php5.c>
+		LoadModule php5_module    modules/libphp5.so
+	</IfModule>
+
+	# Set it to handle the files
+	<IfModule mod_mime.c>
+		AddHandler application/x-httpd-php .php .php5 .phtml
+		AddHandler application/x-httpd-php-source .phps
+	</IfModule>
+
+	DirectoryIndex index.php index.phtml
+</IfDefine>
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/dev-lang/php/files/eblits/src_compile-v1.eblit	Tue Apr 03 07:35:12 2012 +0200
@@ -0,0 +1,60 @@
+# Copyright 1999-2010 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/dev-lang/php/files/eblits/src_compile-v1.eblit,v 1.6 2010/08/14 19:37:31 mabi Exp $
+
+eblit-php-src_compile() {
+	# snmp seems to run during src_compile, too (bug #324739)
+	addpredict /usr/share/snmp/mibs/.index
+
+	SAPI_DIR="${WORKDIR}/sapis"
+
+	for sapi in ${SAPIS} ; do
+		use "${sapi}" || continue
+
+		php_sapi_build "${sapi}"
+		php_sapi_copy "${sapi}"
+	done
+}
+
+php_sapi_build() {
+	mkdir -p "${SAPI_DIR}/$1"
+
+	cd "${WORKDIR}/sapis-build/$1"
+	emake || die "emake failed"
+}
+
+php_sapi_copy() {
+	local sapi="$1"
+	local source=""
+
+	case "$sapi" in
+		cli)
+			source="sapi/cli/php"
+			;;
+		cgi)
+			source="sapi/cgi/php-cgi"
+			;;
+		fpm)
+			source="sapi/fpm/php-fpm"
+			;;
+		embed)
+			source="libs/libphp${PHP_MV}.so"
+			;;
+
+		apache2)
+			# apache2 is a special case; the necessary files
+			# (yes, multiple) are copied by make install, not
+			# by the ebuild; that's the reason, why apache2 has
+			# to be the last sapi
+			emake INSTALL_ROOT="${SAPI_DIR}/${sapi}/" install-sapi
+			;;
+
+		*)
+			die "unhandled sapi in php_sapi_copy"
+			;;
+	esac
+
+	if [[ "${source}" ]] ; then
+		cp "$source" "${SAPI_DIR}/$sapi" || die "Unable to copy ${sapi} SAPI"
+	fi
+}
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/dev-lang/php/files/eblits/src_configure-v521.eblit	Tue Apr 03 07:35:12 2012 +0200
@@ -0,0 +1,273 @@
+# Copyright 1999-2010 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/dev-lang/php/files/eblits/src_configure-v521.eblit,v 1.1 2010/10/08 18:25:10 olemarkus Exp $
+
+eblit-php-src_configure() {
+	export CFLAGS="${CFLAGS} -D_GNU_SOURCE"
+	PHP_DESTDIR="/usr/$(get_libdir)/php${SLOT}"
+
+	# This is a global variable and should be in caps. It isn't because the
+	# phpconfutils eclass relies on exactly this name...
+	my_conf="
+		--prefix="${PHP_DESTDIR}"
+		--mandir="${PHP_DESTDIR}"/man
+		--infodir="${PHP_DESTDIR}"/info
+		--libdir="${PHP_DESTDIR}"/lib
+		--with-libdir=$(get_libdir)
+		--without-pear
+		$(use_enable threads maintainer-zts)"
+
+	phpconfutils_init
+
+	#                             extension	      USE flag        shared
+	phpconfutils_extension_enable  "bcmath"       "bcmath"           1
+	phpconfutils_extension_with    "bz2"          "bzip2"            1
+	phpconfutils_extension_enable  "calendar"     "calendar"         1
+	phpconfutils_extension_disable "ctype"        "ctype"            0
+	phpconfutils_extension_with    "curl"         "curl"             1
+	phpconfutils_extension_with    "curlwrappers" "curlwrappers"     0
+	phpconfutils_extension_enable  "dbase"	      "dbase"			 1
+	phpconfutils_extension_disable "dom"          "xml"              0
+	phpconfutils_extension_enable  "exif"         "exif"             1
+	phpconfutils_extension_with	   "fbsql"		  "frontbase"		 1
+	phpconfutils_extension_with	   "fdftk"		  "fdftk"			 1 "/opt/fdftk-6.0"
+	phpconfutils_extension_disable "filter"       "filter"           0
+	phpconfutils_extension_enable  "ftp"          "ftp"              1
+	phpconfutils_extension_with    "gettext"      "nls"              1
+	phpconfutils_extension_with    "gmp"          "gmp"              1
+	phpconfutils_extension_disable "hash"         "hash"             0
+	phpconfutils_extension_without "iconv"        "iconv"            0
+	phpconfutils_extension_disable "ipv6"         "ipv6"             0
+	phpconfutils_extension_disable "json"         "json"             0
+	phpconfutils_extension_with    "kerberos"     "kerberos"         0 "/usr"
+	phpconfutils_extension_disable "libxml"       "xml"              0
+	phpconfutils_extension_enable  "mbstring"     "unicode"          1
+	phpconfutils_extension_with    "mcrypt"       "crypt"            1
+	phpconfutils_extension_with	   "mhash"		  "mhash"			 1
+	phpconfutils_extension_with	   "msql"		  "msql"			 1
+	phpconfutils_extension_with    "mssql"        "mssql"            1
+	phpconfutils_extension_with	   "ncurses"	  "ncurses"		     1
+	phpconfutils_extension_with    "openssl"      "ssl"              0
+	phpconfutils_extension_with    "openssl-dir"  "ssl"              0 "/usr"
+	phpconfutils_extension_enable  "pcntl"        "pcntl"            1
+	phpconfutils_extension_without	"pcre-regex"  "pcre"			 0
+	phpconfutils_extension_disable "pdo"          "pdo"              0
+	phpconfutils_extension_with    "pgsql"        "postgres"         1
+	phpconfutils_extension_disable "posix"        "posix"            0
+	phpconfutils_extension_with    "pspell"       "spell"            1
+	phpconfutils_extension_with    "recode"       "recode"           1
+	phpconfutils_extension_disable "reflection"   "reflection"       0
+	phpconfutils_extension_disable "simplexml"    "simplexml"        0
+	phpconfutils_extension_enable  "shmop"        "sharedmem"        0
+	phpconfutils_extension_with    "snmp"         "snmp"             1
+	phpconfutils_extension_enable  "soap"         "soap"             1
+	phpconfutils_extension_enable  "sockets"      "sockets"          1
+	phpconfutils_extension_disable "spl"		  "spl"			     0
+	phpconfutils_extension_with    "sybase-ct"    "sybase-ct"        1
+	phpconfutils_extension_enable  "sysvmsg"      "sysvipc"          1
+	phpconfutils_extension_enable  "sysvsem"      "sysvipc"          1
+	phpconfutils_extension_enable  "sysvshm"      "sysvipc"          1
+	phpconfutils_extension_with    "tidy"         "tidy"             1
+	phpconfutils_extension_disable "tokenizer"    "tokenizer"        0
+	phpconfutils_extension_enable  "wddx"         "wddx"             1
+	phpconfutils_extension_disable "xml"          "xml"              0
+	phpconfutils_extension_disable "xmlreader"    "xmlreader"        0
+	phpconfutils_extension_disable "xmlwriter"    "xmlwriter"        0
+	phpconfutils_extension_with    "xmlrpc"       "xmlrpc"           1
+	phpconfutils_extension_with    "xsl"          "xsl"              1
+	phpconfutils_extension_enable  "zip"          "zip"              1
+	phpconfutils_extension_with    "zlib"         "zlib"             1
+	phpconfutils_extension_enable  "debug"        "debug"            0
+
+	# DBA support
+	if use cdb || use berkdb || use flatfile || use gdbm || use inifile \
+		|| use qdbm ; then
+		my_conf="${my_conf} --enable-dba${shared}"
+	fi
+
+	# DBA drivers support
+	phpconfutils_extension_with   "cdb"        "cdb"      0
+	phpconfutils_extension_with   "db4"        "berkdb"   0
+	phpconfutils_extension_enable "flatfile"   "flatfile" 0
+	phpconfutils_extension_with   "gdbm"       "gdbm"     0
+	phpconfutils_extension_enable "inifile"    "inifile"  0
+	phpconfutils_extension_with   "qdbm"       "qdbm"     0
+
+	# Support for the GD graphics library
+	if use gd-external ; then
+		phpconfutils_extension_with   "freetype-dir" "truetype"    0 "/usr"
+		phpconfutils_extension_with   "t1lib"        "truetype"    0 "/usr"
+		phpconfutils_extension_enable "gd-jis-conv"  "cjk"         0
+		phpconfutils_extension_with   "gd"           "gd-external" 1 "/usr"
+	else
+		phpconfutils_extension_with   "freetype-dir" "truetype"    0 "/usr"
+		phpconfutils_extension_with   "t1lib"        "truetype"    0 "/usr"
+		phpconfutils_extension_enable "gd-jis-conv"  "cjk"         0
+		phpconfutils_extension_with   "jpeg-dir"     "gd"          0 "/usr"
+		phpconfutils_extension_with   "png-dir"      "gd"          0 "/usr"
+		phpconfutils_extension_with   "xpm-dir"      "xpm"         0 "/usr"
+		# enable gd last, so configure can pick up the previous settings
+		phpconfutils_extension_with   "gd"           "gd"          0
+	fi
+
+	# IMAP support
+	if use imap ; then
+		phpconfutils_extension_with "imap"     "imap" 1
+		phpconfutils_extension_with "imap-ssl" "ssl"  0
+	fi
+
+	phpconfutils_extension_with "interbase"	"interbase"	0 "/opt"
+	phpconfutils_extension_with	"interbase"	"firebird"	0 "/usr"
+
+	# LDAP support
+	if use ldap ; then
+		if use oci8 ; then
+			phpconfutils_extension_with "ldap" "ldap" 1 "${ORACLE_HOME}"
+		else
+			phpconfutils_extension_with "ldap"      "ldap"      1
+			phpconfutils_extension_with "ldap-sasl" "ldap-sasl" 0
+		fi
+	fi
+
+	# MySQL support
+	if use mysql ; then
+		phpconfutils_extension_with "mysql"      "mysql" 1 "/usr"
+		phpconfutils_extension_with "mysql-sock" "mysql" 0 "/var/run/mysqld/mysqld.sock"
+	fi
+
+	# MySQLi support
+	phpconfutils_extension_with "mysqli" "mysqli" 1 "/usr/bin/mysql_config"
+
+	# ODBC support
+	if use odbc ; then
+		phpconfutils_extension_with "unixODBC" "odbc"     1 "/usr"
+		phpconfutils_extension_with "adabas"   "adabas"   1
+		phpconfutils_extension_with "birdstep" "birdstep" 1
+		phpconfutils_extension_with "dbmaker"  "dbmaker"  1
+		phpconfutils_extension_with "empress"  "empress"  1
+		if use empress ; then
+			phpconfutils_extension_with "empress-bcs" "empress-bcs" 0
+		fi
+		phpconfutils_extension_with "esoob"   "esoob" 1
+		# Needed to run conftest for IBM DB2
+		[[ -n ${DB2_HOME} ]] && export LD_LIBRARY_PATH="${DB2_HOME}/`get_libdir`"
+		phpconfutils_extension_with "ibm-db2" "db2"   1 "${DB2_HOME}"
+		phpconfutils_extension_with "sapdb"   "sapdb" 1
+		phpconfutils_extension_with "solid"   "solid" 1
+	fi
+
+	if use iodbc ; then
+		phpconfutils_extension_with "iodbc"   "iodbc" 1 "/usr"
+	fi
+
+	# Oracle support
+	phpconfutils_extension_with "oci8" "oci8" 1
+	if use oci8-instant-client ; then
+		OCI8IC_PKG="$(best_version dev-db/oracle-instantclient-basic | \
+			sed -e 's|dev-db/oracle-instantclient-basic-||g' | \
+			sed -e 's|-r.*||g')"
+
+		phpconfutils_extension_with "oci8" "oci8-instant-client" 1 \
+			"instantclient,/usr/lib/oracle/${OCI8IC_PKG}/client/lib"
+	fi
+
+	# PDO support
+	if use pdo ; then
+		phpconfutils_extension_with "pdo-dblib"  "mssql"    1
+		phpconfutils_extension_with "pdo-mysql"  "mysql"    1 "/usr"
+		phpconfutils_extension_with "pdo-pgsql"  "postgres"	1
+		phpconfutils_extension_with "pdo-sqlite" "sqlite"   1 "/usr"
+		phpconfutils_extension_with "pdo-odbc"   "odbc"     1 "unixODBC,/usr"
+		if use oci8 ; then
+			phpconfutils_extension_with "pdo-oci" "oci8" 1
+		fi
+		if use oci8-instant-client ; then
+			phpconfutils_extension_with "pdo-oci" "oci8-instant-client" 1 \
+				"instantclient,/usr,${OCI8IC_PKG}"
+		fi
+	fi
+
+	# readline/libedit support
+	phpconfutils_extension_with "readline" "readline" 0
+	phpconfutils_extension_with "libedit"  "libedit"  0
+
+	# Session support
+	if use session ; then
+		phpconfutils_extension_with "mm" "sharedmem" 0
+	else
+		phpconfutils_extension_disable "session" "session" 0
+	fi
+
+	# SQLite support
+	if use sqlite ; then
+		phpconfutils_extension_with   "sqlite"      "sqlite"  0 "/usr"
+		phpconfutils_extension_enable "sqlite-utf8" "unicode" 0
+	else
+		phpconfutils_extension_without "sqlite" "sqlite" 0
+	fi
+
+	if use pic ; then
+		my_conf="${my_conf} --with-pic"
+	fi
+
+	
+	# we use the system copy of pcre
+	# --with-pcre-regex affects ext/pcre
+	# --with-pcre-dir affects ext/filter and ext/zip
+	if use pcre ; then
+		my_conf="${my_conf} --with-pcre-regex=/usr --with-pcre-dir=/usr"
+	fi
+
+	# Catch CFLAGS problems
+	php_check_cflags
+
+	# Support user-passed configuration parameters
+	my_conf="${my_conf} ${EXTRA_ECONF:-}"
+
+	# Support the Apache2 extras, they must be set globally for all
+	# SAPIs to work correctly, especially for external PHP extensions
+
+	mkdir -p "${WORKDIR}/sapis-build"
+	for one_sapi in $SAPIS ; do
+		use "${one_sapi}" || continue
+		php_set_ini_dir "${one_sapi}"
+
+		cp -r "${S}" "${WORKDIR}/sapis-build/${one_sapi}"
+		cd "${WORKDIR}/sapis-build/${one_sapi}"
+
+		sapi_conf="${my_conf} --with-config-file-path=${PHP_INI_DIR}
+			--with-config-file-scan-dir=${PHP_EXT_INI_DIR_ACTIVE}"
+
+		for sapi in $SAPIS ; do
+			case "$sapi" in
+				cli|embed)
+					if [[ "${one_sapi}" == "${sapi}" ]] ; then
+						sapi_conf="${sapi_conf} --enable-${sapi}"
+					else
+						sapi_conf="${sapi_conf} --disable-${sapi}"
+					fi
+					;;
+
+				cgi)
+					if [[ "${one_sapi}" == "${sapi}" ]] ; then
+						sapi_conf+=" --enable-cgi --enable-fastcgi"
+						use discard-path && sapi_conf+=" --enable-discard-path"
+						use force-cgi-redirect && sapi_conf+=" --enable-force-cgi-redirect"
+					else
+						sapi_conf+=" --disable-${sapi}"
+					fi
+					;;
+
+				apache2)
+					if [[ "${one_sapi}" == "${sapi}" ]] ; then
+						sapi_conf="${sapi_conf} --with-apxs2=/usr/sbin/apxs"
+					else
+						sapi_conf="${sapi_conf} --without-apxs2"
+					fi
+					;;
+			esac
+		done
+
+		econf ${sapi_conf}
+	done
+}
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/dev-lang/php/files/eblits/src_install-v2.eblit	Tue Apr 03 07:35:12 2012 +0200
@@ -0,0 +1,165 @@
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/dev-lang/php/files/eblits/src_install-v2.eblit,v 1.14 2011/12/16 09:02:43 olemarkus Exp $
+
+eblit-php-src_install() {
+	# see bug #324739 for what happens when we don't have that
+	addpredict /usr/share/snmp/mibs/.index
+
+	# grab the first SAPI that got built and install common files from there
+	local first_sapi=""
+	for sapi in $SAPIS ; do
+		if use $sapi ; then
+			first_sapi=$sapi
+			break
+		fi
+	done
+
+	# Makefile forgets to create this before trying to write to it...
+	dodir "${PHP_DESTDIR}/bin"
+
+	# Install php environment (without any sapis)
+	cd "${WORKDIR}/sapis-build/$first_sapi"
+	emake INSTALL_ROOT="${D}" \
+		install-build install-headers install-programs \
+		|| die "emake install failed"
+
+	local extension_dir="$("${D}/${PHP_DESTDIR}/bin/php-config" --extension-dir)"
+
+	# And install the modules to it
+	if use sharedext ; then
+		insinto "${extension_dir}"
+		doins "${WORKDIR}/sapis-build/${first_sapi}/modules/"*.so
+	fi
+
+	# Create the directory where we'll put version-specific php scripts
+	keepdir /usr/share/php${PHP_MV}
+
+	local sapi="", file=""
+	local sapi_list=""
+
+	for sapi in ${SAPIS}; do
+		if use "${sapi}" ; then
+			einfo "Installing SAPI: ${sapi}"
+			cd "${WORKDIR}/sapis-build/${sapi}"
+			# needed each time, php_install_ini would reset it
+			into "${PHP_DESTDIR}"
+			file=$(find "${SAPI_DIR}/${sapi}/" -type f | head -n 1)
+
+			if [[ "${file: -3}" == ".so" ]]; then 
+				if [[ "${sapi}" == "apache2" ]]; then
+					insinto "${PHP_DESTDIR}/apache2/"
+					newins "${file}" "${file/*\/}"
+                    keepdir "/usr/$(get_libdir)/apache2/modules"
+				else
+					dolib.so "${file}" || die "Unable to install ${sapi} sapi"
+				fi
+			else
+				dobin "${file}" || die "Unable to install ${sapi} sapi"
+			fi
+
+			php_install_ini "${sapi}"
+
+			# construct correct SAPI string for php-config
+			# thanks to ferringb for the bash voodoo
+			if [[ "${sapi}" == "apache2" ]]; then
+			    sapi_list="${sapi_list:+${sapi_list} }apache2handler"
+			else
+				sapi_list="${sapi_list:+${sapi_list} }${sapi}"
+			fi
+		fi
+	done
+
+	# Install env.d files
+	newenvd "${FILESDIR}/20php5-envd" \
+		"20php${SLOT}"
+	sed -e "s|/lib/|/$(get_libdir)/|g" -i \
+		"${D}/etc/env.d/20php${SLOT}"
+	sed -e "s|php5|php${SLOT}|g" -i \
+		"${D}/etc/env.d/20php${SLOT}"
+
+	# set php-config variable correctly (bug #278439)
+	sed -e "s:^\(php_sapis=\)\".*\"$:\1\"${sapi_list}\":" -i \
+		"${D}/usr/$(get_libdir)/php${SLOT}/bin/php-config"
+}
+
+php_install_ini() {
+	local phpsapi="${1}"
+
+	# work out where we are installing the ini file
+	php_set_ini_dir "${phpsapi}"
+
+	local phpinisrc="${PHP_INI_UPSTREAM}-${phpsapi}"
+	cp "${PHP_INI_UPSTREAM}" "${phpinisrc}"
+
+	# default to allow_url_open=Off, bug 332763
+	sed -e 's|^allow_url_fopen .*|allow_url_fopen = Off|g' -i "${phpinisrc}"
+
+	# default to expose_php=Off, bug 300695
+	sed -e 's|^expose_php .*|expose_php = Off|g' -i "${phpinisrc}"
+
+	# default to /tmp for save_path, bug #282768
+	sed -e 's|^;session.save_path .*$|session.save_path = "/tmp"|g' -i "${phpinisrc}"
+
+	# Set the extension dir
+	sed -e "s|^extension_dir .*$|extension_dir = ${extension_dir}|g" -i "${phpinisrc}"
+
+	# Set the include path to point to where we want to find PEAR packages
+	sed -e 's|^;include_path = ".:/php/includes".*|include_path = ".:/usr/share/php'${PHP_MV}':/usr/share/php"|' -i "${phpinisrc}"
+
+	dodir "${PHP_INI_DIR}"
+	insinto "${PHP_INI_DIR}"
+	newins "${phpinisrc}" "${PHP_INI_FILE}"
+
+	elog "Installing php.ini for ${phpsapi} into ${PHP_INI_DIR}"
+	elog
+
+	dodir "${PHP_EXT_INI_DIR}"
+	dodir "${PHP_EXT_INI_DIR_ACTIVE}"
+
+	# Install any extensions built as shared objects
+	if use sharedext ; then
+		insinto "${PHP_EXT_INI_DIR}"
+		for extension in "${D}/${extension_dir}/"*.so ; do
+			extension="${extension##*/}"
+			inifilename="${extension/.so/.ini}"
+			echo "extension=${extension}" > "${WORKDIR}/sapis-build/${phpsapi}/modules/$inifilename"
+			doins "${WORKDIR}/sapis-build/${phpsapi}/modules/$inifilename"
+			dosym "${PHP_EXT_INI_DIR}/${inifilename}" "${PHP_EXT_INI_DIR_ACTIVE}/${inifilename}"
+		done
+	fi
+
+	# SAPI-specific handling
+	if [[ "${sapi}" == "apache2" ]] ; then
+			insinto "${APACHE_MODULES_CONFDIR}"
+			newins "${FILESDIR}/70_mod_php${PHP_MV}.conf-apache2" \
+				"70_mod_php${PHP_MV}.conf"
+	fi
+
+	if [[ "${sapi}" == "fpm" ]] ; then
+        [[ -z ${PHP_FPM_INIT_VER} ]] && PHP_FPM_INIT_VER=3
+        [[ -z ${PHP_FPM_CONF_VER} ]] && PHP_FPM_CONF_VER=0
+		einfo "Installing FPM CGI config file php-fpm.conf"
+		insinto ${PHP_INI_DIR}
+		newins "${FILESDIR}/php-fpm-r${PHP_FPM_CONF_VER}.conf" php-fpm.conf
+		dodir "/etc/init.d"
+		insinto "/etc/init.d"
+		newinitd "${FILESDIR}/php-fpm-r${PHP_FPM_INIT_VER}.init" "php-fpm"
+		#dosym "${PHP_DESTDIR}/bin/php-fpm" "/usr/bin/php-fpm"
+		
+		# Remove bogus /etc/php-fpm.conf.default (bug 359906)
+		[[ -f "${D}/etc/php-fpm.conf.default" ]] && rm "${D}/etc/php-fpm.conf.default"
+	fi
+
+  # Install PHP ini files into /usr/share/php
+	if [[ ${SLOT} == '5.2' ]]; then
+		newdoc php.ini-dist php.ini-development
+		newdoc php.ini-recommended php.ini-production
+	fi
+
+	if [[ ${SLOT} == '5.3' ]]; then
+		dodoc php.ini-development
+		dodoc php.ini-production
+	fi
+
+}
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/dev-lang/php/files/eblits/src_prepare-v2.eblit	Tue Apr 03 07:35:12 2012 +0200
@@ -0,0 +1,71 @@
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/dev-lang/php/files/eblits/src_prepare-v2.eblit,v 1.3 2011/01/05 11:23:16 mabi Exp $
+
+eblit-php-src_prepare() {
+	# USE=sharedmem (session/mod_mm to be exact) tries to mmap() this path
+	# ([empty session.save_path]/session_mm_[sapi][gid].sem)
+	# there is no easy way to circumvent that, all php calls during
+	# install use -n, so no php.ini file will be used.
+	# As such, this is the easiest way to get around
+	addpredict /session_mm_cli250.sem
+	addpredict /session_mm_cli0.sem
+
+	# kolab support (support for imap annotations)
+	use kolab && epatch "${WORKDIR}/${PV}/opt/imap-kolab-annotations.patch"
+
+	# Change PHP branding
+	sed -re	"s|^(PHP_EXTRA_VERSION=\").*(\")|\1${PHP_EXTRA_BRANDING}-pl${PR/r/}-gentoo\2|g" \
+		-i configure.in || die "Unable to change PHP branding"
+
+	# Apply generic PHP patches
+	EPATCH_SOURCE="${WORKDIR}/${PV}/generic" EPATCH_SUFFIX="patch" \
+		EPATCH_FORCE="yes" \
+		EPATCH_MULTI_MSG="Applying generic patches and fixes from upstream..." epatch
+
+	# Patch PHP to show Gentoo as the server platform
+	sed -e 's/PHP_UNAME=`uname -a | xargs`/PHP_UNAME=`uname -s -n -r -v | xargs`/g' \
+		-i configure.in || die "Failed to fix server platform name"
+
+	# Prevent PHP from activating the Apache config,
+	# as we will do that ourselves
+	sed -i \
+		-e "s,-i -a -n php${PHP_MV},-i -n php${PHP_MV},g" \
+		-e "s,-i -A -n php${PHP_MV},-i -n php${PHP_MV},g" \
+		configure sapi/apache2filter/config.m4 sapi/apache2handler/config.m4
+
+	# Patch PHP to support heimdal instead of mit-krb5
+	if has_version "app-crypt/heimdal" ; then
+		sed -e 's|gssapi_krb5|gssapi|g' -i acinclude.m4 \
+			|| die "Failed to fix heimdal libname"
+		sed -e 's|PHP_ADD_LIBRARY(k5crypto, 1, $1)||g' -i acinclude.m4 \
+			|| die "Failed to fix heimdal crypt library reference"
+	fi
+
+	# Suhosin support
+	if [[ -n $SUHOSIN_VERSION ]] ; then
+		if use suhosin ; then
+			epatch "${WORKDIR}/${SUHOSIN_PATCH}"
+		fi
+	else
+		ewarn "Please note that this version of PHP does not yet come with a suhosin patch"
+	fi
+
+
+	# rebuild the whole autotools stuff as we are heavily patching it
+	# (suhosin, fastbuild, ...)
+
+	# eaclocal doesn't accept --force, so we try to force re-generation
+	# this way
+	rm aclocal.m4
+
+	# work around divert() issues with newer autoconf, bug #281697
+	if has_version '>=sys-devel/autoconf-2.64' ; then
+		sed -i -r \
+			-e 's:^((m4_)?divert)[(]([0-9]*)[)]:\1(600\3):' \
+			$(grep -l divert $(find . -name '*.m4') configure.in) || die
+	fi
+	eautoreconf --force -W no-cross
+}
+
+
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/dev-lang/php/files/eblits/src_test-v1.eblit	Tue Apr 03 07:35:12 2012 +0200
@@ -0,0 +1,54 @@
+# Copyright 1999-2012 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/dev-lang/php/files/eblits/src_test-v1.eblit,v 1.3 2012/02/06 13:53:17 olemarkus Exp $
+
+eblit-php-src_test() {
+	vecho ">>> Test phase [test]: ${CATEGORY}/${PF}"
+	PHP_BIN="${WORKDIR}/sapis-build/cli/sapi/cli/php"
+	if [[ ! -x "${PHP_BIN}" ]] ; then
+		ewarn "Test phase requires USE=cli, skipping"
+		return
+	else
+		export TEST_PHP_EXECUTABLE="${PHP_BIN}"
+	fi
+
+	if [[ -x "${WORKDIR}/sapis/cgi/php-cgi" ]] ; then
+		export TEST_PHP_CGI_EXECUTABLE="${WORKDIR}/sapis/cgi/php-cgi"
+	fi
+	
+	
+	REPORT_EXIT_STATUS=1 "${TEST_PHP_EXECUTABLE}" -n  -d "session.save_path=${T}" \
+		"${WORKDIR}/sapis-build/cli/run-tests.php" -n -q -d "session.save_path=${T}"
+
+	for name in ${EXPECTED_TEST_FAILURES}; do
+		mv "${name}.out" "${name}.out.orig" 2>/dev/null
+	done
+
+	local failed="$(find -name '*.out')"
+	if [[ ${failed} != "" ]] ; then
+		ewarn "The following test cases failed unexpectedly:"
+		for name in ${failed}; do
+			ewarn "  ${name/.out/}"
+		done
+	else
+		einfo "No unexpected test failures, all fine"
+	fi
+
+	if [[ ${PHP_SHOW_UNEXPECTED_TEST_PASS} == "1" ]] ; then
+		local passed=""
+		for name in ${EXPECTED_TEST_FAILURES}; do
+			[[ -f "${name}.diff" ]] && continue
+			passed="${passed} ${name}"
+		done
+		if [[ ${passed} != "" ]] ; then
+			einfo "The following test cases passed unexpectedly:"
+			for name in ${passed}; do
+				ewarn "  ${passed}"
+			done
+		else
+			einfo "None of the known-to-fail tests passed, all fine"
+		fi
+	fi
+}
+
+
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/dev-lang/php/php-5.2.17.ebuild	Tue Apr 03 07:35:12 2012 +0200
@@ -0,0 +1,389 @@
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/dev-lang/php/Attic/php-5.2.17.ebuild,v 1.18 2012/01/21 09:49:56 olemarkus dead $
+
+EAPI=2
+
+PHPCONFUTILS_MISSING_DEPS="adabas birdstep db2 dbmaker empress empress-bcs esoob
+interbase msql oci8 sapdb solid"
+
+inherit eutils autotools flag-o-matic versionator depend.apache apache-module db-use phpconfutils php-common-r1 libtool
+
+#SUHOSIN_VERSION="$PV-0.9.7"
+SUHOSIN_VERSION="5.2.16-0.9.7"
+EXPECTED_TEST_FAILURES=""
+
+KEYWORDS="alpha amd64 arm hppa ia64 ppc ppc64 s390 sh sparc x86"
+
+function php_get_uri ()
+{
+	case "${1}" in
+		"php-pre")
+			echo "http://downloads.php.net/johannes/${2}"
+		;;
+		"php")
+			echo "http://www.php.net/distributions/${2}"
+		;;
+		"suhosin")
+			echo "http://download.suhosin.org/${2}"
+		;;
+		"gentoo")
+			echo "mirror://gentoo/${2}"
+		;;
+		*)
+			die "unhandled case in php_get_uri"
+		;;
+	esac
+}
+
+PHP_MV="$(get_major_version)"
+
+# alias, so we can handle different types of releases (finals, rcs, alphas,
+# betas, ...) w/o changing the whole ebuild
+PHP_PV="${PV/_rc/RC}"
+PHP_RELEASE="php"
+PHP_P="${PN}-${PHP_PV}"
+PHP_SRC_URI="$(php_get_uri "${PHP_RELEASE}" "${PHP_P}.tar.bz2")"
+
+PHP_PATCHSET="0"
+PHP_PATCHSET_URI="
+	$(php_get_uri gentoo "php-patchset-${PV}-r${PHP_PATCHSET}.tar.bz2")"
+
+if [[ ${SUHOSIN_VERSION} == *-gentoo ]]; then
+	# in some cases we use our own suhosin patch (very recent version,
+	# patch conflicts, etc.)
+	SUHOSIN_TYPE="gentoo"
+else
+	SUHOSIN_TYPE="suhosin"
+fi
+
+if [[ -n ${SUHOSIN_VERSION} ]]; then
+	SUHOSIN_PATCH="suhosin-patch-${SUHOSIN_VERSION}.patch"
+	SUHOSIN_URI="$(php_get_uri ${SUHOSIN_TYPE} ${SUHOSIN_PATCH}.gz )"
+fi
+
+SRC_URI="
+	${PHP_SRC_URI}
+	${PHP_PATCHSET_URI}"
+
+if [[ -n ${SUHOSIN_VERSION} ]]; then
+	SRC_URI="${SRC_URI}
+		suhosin? ( ${SUHOSIN_URI} )"
+fi
+
+DESCRIPTION="The PHP language runtime engine: CLI, CGI, Apache2 and embed SAPIs."
+HOMEPAGE="http://php.net/"
+LICENSE="PHP-3"
+
+# We can build the following SAPIs in the given order
+SAPIS="cli cgi embed apache2"
+
+# Gentoo-specific, common features
+IUSE="kolab"
+
+# SAPIs and SAPI-specific USE flags (cli SAPI is default on):
+IUSE="${IUSE}
+	${SAPIS/cli/+cli}
+	threads force-cgi-redirect discard-path"
+
+IUSE="${IUSE} adabas bcmath berkdb birdstep bzip2 calendar cdb cjk
+	crypt +ctype curl curlwrappers db2 dbase dbmaker debug doc empress
+	empress-bcs esoob exif fdftk frontbase +filter firebird
+	flatfile ftp gd gd-external gdbm gmp +hash +iconv imap inifile
+	interbase iodbc ipv6 +json kerberos ldap ldap-sasl libedit
+	mhash msql mssql mysql mysqli ncurses nls oci8
+	oci8-instant-client odbc pcntl +pcre pdo pic +posix postgres qdbm
+	readline recode reflection sapdb +session sharedext sharedmem
+	+simplexml snmp soap sockets solid spell spl sqlite ssl suhosin
+	sybase-ct sysvipc tidy +tokenizer truetype unicode wddx
+	xml xmlreader xmlwriter xmlrpc xpm xsl zip zlib"
+
+# Enable suhosin if available
+[[ -n $SUHOSIN_VERSION ]] && IUSE="${IUSE} suhosin"
+
+DEPEND=">=app-admin/eselect-php-0.6.2
+	pcre? ( >=dev-libs/libpcre-7.9[unicode] )
+	adabas? ( >=dev-db/unixODBC-1.8.13 )
+	apache2? ( www-servers/apache[threads=] )
+	berkdb? ( =sys-libs/db-4* )
+	birdstep? ( >=dev-db/unixODBC-1.8.13 )
+	bzip2? ( app-arch/bzip2 )
+	cdb? ( || ( dev-db/cdb dev-db/tinycdb ) )
+	cjk? ( !gd? ( !gd-external? (
+		virtual/jpeg
+		media-libs/libpng
+		sys-libs/zlib
+	) ) )
+	crypt? ( >=dev-libs/libmcrypt-2.4 )
+	curl? ( >=net-misc/curl-7.10.5 )
+	db2? ( >=dev-db/unixODBC-1.8.13 )
+	dbmaker? ( >=dev-db/unixODBC-1.8.13 )
+	empress? ( >=dev-db/unixODBC-1.8.13 )
+	empress-bcs? ( >=dev-db/unixODBC-1.8.13 )
+	esoob? ( >=dev-db/unixODBC-1.8.13 )
+	exif? ( !gd? ( !gd-external? (
+		virtual/jpeg
+		media-libs/libpng
+		sys-libs/zlib
+	) ) )
+	fdftk? ( app-text/fdftk )
+	firebird? ( dev-db/firebird )
+	gd? ( virtual/jpeg media-libs/libpng sys-libs/zlib )
+	gd-external? ( media-libs/gd )
+	gdbm? ( >=sys-libs/gdbm-1.8.0 )
+	gmp? ( >=dev-libs/gmp-4.1.2 )
+	iconv? ( virtual/libiconv )
+	imap? ( virtual/imap-c-client[ssl=] )
+	iodbc? ( dev-db/libiodbc )
+	kerberos? ( virtual/krb5 )
+	kolab? ( >=net-libs/c-client-2004g-r1 )
+	ldap? ( !oci8? ( >=net-nds/openldap-1.2.11 ) )
+	ldap-sasl? ( !oci8? ( dev-libs/cyrus-sasl >=net-nds/openldap-1.2.11 ) )
+	libedit? ( || ( sys-freebsd/freebsd-lib dev-libs/libedit ) )
+	mhash? ( app-crypt/mhash )
+	mssql? ( dev-db/freetds[mssql] )
+	mysql? ( virtual/mysql )
+	mysqli? ( >=virtual/mysql-4.1 )
+	ncurses? ( sys-libs/ncurses )
+	nls? ( sys-devel/gettext )
+	oci8-instant-client? ( dev-db/oracle-instantclient-basic )
+	odbc? ( >=dev-db/unixODBC-1.8.13 )
+	postgres? ( dev-db/postgresql-base )
+	qdbm? ( dev-db/qdbm )
+	readline? ( sys-libs/readline )
+	recode? ( app-text/recode )
+	sapdb? ( >=dev-db/unixODBC-1.8.13 )
+	sharedmem? ( dev-libs/mm )
+	simplexml? ( >=dev-libs/libxml2-2.6.8 )
+	snmp? ( >=net-analyzer/net-snmp-5.2 )
+	soap? ( >=dev-libs/libxml2-2.6.8 )
+	solid? ( >=dev-db/unixODBC-1.8.13 )
+	spell? ( >=app-text/aspell-0.50 )
+	sqlite? ( =dev-db/sqlite-2* pdo? ( =dev-db/sqlite-3* ) )
+	ssl? ( >=dev-libs/openssl-0.9.7 )
+	sybase-ct? ( dev-db/freetds )
+	tidy? ( app-text/htmltidy )
+	truetype? (
+		=media-libs/freetype-2*
+		>=media-libs/t1lib-5.0.0
+		!gd? ( !gd-external? (
+			virtual/jpeg media-libs/libpng sys-libs/zlib ) )
+	)
+	wddx? ( >=dev-libs/libxml2-2.6.8 )
+	xml? ( >=dev-libs/libxml2-2.6.8 )
+	xmlrpc? ( >=dev-libs/libxml2-2.6.8 virtual/libiconv )
+	xmlreader? ( >=dev-libs/libxml2-2.6.8 )
+	xmlwriter? ( >=dev-libs/libxml2-2.6.8 )
+	xpm? (
+		x11-libs/libXpm
+		virtual/jpeg
+		media-libs/libpng sys-libs/zlib
+	)
+	xsl? ( dev-libs/libxslt >=dev-libs/libxml2-2.6.8 )
+	zip? ( sys-libs/zlib )
+	zlib? ( sys-libs/zlib )
+	virtual/mta
+"
+
+php="=${CATEGORY}/${PF}"
+RDEPEND="${DEPEND}
+	truetype? ( || ( $php[gd] $php[gd-external] ) )
+	cjk? ( || ( $php[gd] $php[gd-external] ) )
+	exif? ( || ( $php[gd] $php[gd-external] ) )
+
+	xpm? ( $php[gd] )
+	gd? ( $php[zlib,-gd-external] )
+	gd-external? ( $php[-gd] )
+	simplexml? ( $php[xml] )
+	soap? ( $php[xml] )
+	wddx? ( $php[xml] )
+	xmlrpc? ( || ( $php[xml] $php[iconv] ) )
+	xmlreader? ( $php[xml] )
+	xsl? ( $php[xml] )
+	ldap-sasl? ( $php[ldap,-oci8] )
+	suhosin? ( $php[unicode] )
+	adabas? ( $php[odbc] )
+	birdstep? ( $php[odbc] )
+	dbmaker? ( $php[odbc] )
+	empress-bcs? ( $php[empress] )
+	empress? ( $php[odbc] )
+	esoob? ( $php[odbc] )
+	db2? ( $php[odbc] )
+	sapdb? ( $php[odbc] )
+	solid? ( $php[odbc] )
+	kolab? ( $php[imap] )
+
+	oci8? ( $php[-oci8-instant-client,-ldap-sasl] )
+	oci8-instant-client? ( $php[-oci8] )
+
+	qdbm? ( $php[-gdbm] )
+	readline? ( $php[-libedit] )
+	recode? ( $php[-imap,-mysql,-mysqli] )
+	firebird? ( $php[-interbase] )
+	sharedmem? ( $php[-threads] )
+
+	!cli? ( !cgi? ( !apache2? ( !embed? ( $php[cli] ) ) ) )
+
+	filter? ( !dev-php${PHP_MV}/pecl-filter )
+	json? ( !dev-php${PHP_MV}/pecl-json )
+	zip? ( !dev-php${PHP_MV}/pecl-zip )"
+
+[[ -n $SUHOSIN_VERSION ]] && RDEPEND="${RDEPEND} suhosin? ( $php[unicode] )"
+
+DEPEND="${DEPEND}
+	sys-devel/flex
+	>=sys-devel/m4-1.4.3
+	>=sys-devel/libtool-1.5.18"
+
+# They are in PDEPEND because we need PHP installed first!
+PDEPEND="doc? ( app-doc/php-docs )"
+
+SLOT="$(get_version_component_range 1-2)"
+S="${WORKDIR}/${PHP_P}"
+
+# Allow users to install production version if they want to
+# PHP 5.2 has other filenames for prod and dev versions
+
+case "${PHP_INI_VERSION}" in
+	production)
+		PHP_INI_UPSTREAM="php.ini-recommended"
+		;;
+	development)
+		PHP_INI_UPSTREAM="php.ini-dist"
+		;;
+	*)
+		PHP_INI_VERSION="development"
+		PHP_INI_UPSTREAM="php.ini-dist"
+		;;
+esac
+
+PHP_INI_FILE="php.ini"
+
+want_apache
+
+# eblit-core
+# Usage: <function> [version] [eval]
+# Main eblit engine
+eblit-core() {
+	[[ -z $FILESDIR ]] && FILESDIR="$(dirname $EBUILD)/files"
+	local e v func=$1 ver=$2 eval_=$3
+	for v in ${ver:+-}${ver} -${PVR} -${PV} "" ; do
+		e="${FILESDIR}/eblits/${func}${v}.eblit"
+		if [[ -e ${e} ]] ; then
+			. "${e}"
+			[[ ${eval_} == 1 ]] && eval "${func}() { eblit-run ${func} ${ver} ; }"
+			return 0
+		fi
+	done
+	return 1
+}
+
+# eblit-include
+# Usage: [--skip] <function> [version]
+# Includes an "eblit" -- a chunk of common code among ebuilds in a given
+# package so that its functions can be sourced and utilized within the
+# ebuild.
+eblit-include() {
+	local skipable=false r=0
+	[[ $1 == "--skip" ]] && skipable=true && shift
+	[[ $1 == pkg_* ]] && skipable=true
+
+	[[ -z $1 ]] && die "Usage: eblit-include <function> [version]"
+	eblit-core $1 $2
+	r="$?"
+	${skipable} && return 0
+	[[ "$r" -gt "0" ]] && die "Could not locate requested eblit '$1' in ${FILESDIR}/eblits/"
+}
+
+# eblit-run-maybe
+# Usage: <function>
+# Runs a function if it is defined in an eblit
+eblit-run-maybe() {
+	[[ $(type -t "$@") == "function" ]] && "$@"
+}
+
+# eblit-run
+# Usage: <function> [version]
+# Runs a function defined in an eblit
+eblit-run() {
+	eblit-include --skip common "v2"
+	eblit-include "$@"
+	eblit-run-maybe eblit-$1-pre
+	eblit-${PN}-$1
+	eblit-run-maybe eblit-$1-post
+}
+
+# eblit-pkg
+# Usage: <phase> [version]
+# Includes the given functions AND evals them so they're included in the binpkgs
+eblit-pkg() {
+	[[ -z $1 ]] && die "Usage: eblit-pkg <phase> [version]"
+	eblit-core $1 $2 1
+}
+
+eblit-pkg pkg_setup v2
+
+src_prepare() { eblit-run src_prepare v2 ; }
+src_configure() { eblit-run src_configure v521 ; }
+src_compile() { eblit-run src_compile v1 ; }
+src_install() { eblit-run src_install v2 ; }
+src_test() { eblit-run src_test v1 ; }
+
+#Do not use eblit for this because it will not get sourced when installing from
+#binary package (bug #380845)
+pkg_postinst() {
+	# Output some general info to the user
+	if use apache2 ; then
+		APACHE2_MOD_DEFINE="PHP5"
+		APACHE2_MOD_CONF="70_mod_php5"
+		apache-module_pkg_postinst
+	fi
+
+	# Create the symlinks for php
+	for m in ${SAPIS}; do
+		[[ ${m} == 'embed' ]] && continue;
+		if use $m ; then
+			local ci=$(eselect php show $m)
+			if [[ -z $ci ]]; then
+				eselect php set $m php${SLOT}
+				einfo "Switched ${m} to use php:${SLOT}"
+				einfo
+			elif [[ $ci != "php${SLOT}" ]] ; then
+				elog "To switch $m to use php:${SLOT}, run"
+				elog "    eselect php set $m php${SLOT}"
+				elog
+			fi
+		fi
+	done
+
+	elog "Make sure that PHP_TARGETS in /etc/make.conf includes php${SLOT/./-} in order"
+	elog "to compile extensions for the ${SLOT} ABI"
+	elog
+	if ! use readline && use cli ; then
+		ewarn "Note that in order to use php interactivly, you need to enable"
+		ewarn "the readline USE flag or php -a will hang"
+	fi
+	elog
+	elog "This ebuild installed a version of php.ini based on php.ini-${PHP_INI_VERSION} version."
+	elog "You can chose which version of php.ini to install by default by setting PHP_INI_VERSION to either"
+	elog "'production' or 'development' in /etc/make.conf"
+	ewarn "Both versions of php.ini can be found in /usr/share/doc/${PF}"
+
+	# check for not yet migrated old style config dirs
+	ls "${ROOT}"/etc/php/*-php5 &>/dev/null
+	if [[ $? -eq 0 ]]; then
+		ewarn "Make sure to migrate your config files, starting with php-5.3.4 and php-5.2.16 config"
+		ewarn "files are now kept at ${ROOT}etc/php/{apache2,cli,cgi,fpm}-php5.x"
+	fi
+	elog
+	elog "For more details on how minor version slotting works (PHP_TARGETS) please read the upgrade guide:"
+	elog "http://www.gentoo.org/proj/en/php/php-upgrading.xml"
+	elog
+
+	if ( [[ -z SUHOSIN_VERSION ]] && use suhosin && version_is_at_least 5.3.6_rc1 ) ; then
+		ewarn "The suhosin USE flag now only installs the suhosin patch!"
+		ewarn "If you want the suhosin extension, make sure you install"
+		ewarn " dev-php/suhosin"
+		ewarn
+	fi
+}